Package org.jboss.resteasy.plugins.providers.multipart

## Class HeaderFlushedAsyncOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.jboss.resteasy.spi.AsyncOutputStream
    - - org.jboss.resteasy.plugins.providers.multipart.HeaderFlushedAsyncOutputStream

- All Implemented Interfaces:
    `Closeable`, `Flushable`, `AutoCloseable`

      public class HeaderFlushedAsyncOutputStream
      extends AsyncOutputStream

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HeaderFlushedAsyncOutputStream​(javax.ws.rs.core.MultivaluedMap<String,​Object> headers, AsyncOutputStream delegate)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `CompletionStage<Void>` | `asyncFlush()` | Flushes this async output stream.
    `CompletionStage<Void>` | `asyncWrite​(byte[] bytes, int offset, int length)` | Writes to this async output stream.
    `void` | `close()` |
    `void` | `flush()` |
    `protected CompletionStage<Void>` | `flushHeaders()` |
    `void` | `write​(byte[] bytes)` |
    `void` | `write​(byte[] bytes, int i, int i1)` |
    `void` | `write​(int i)` |

    - ### Methods inherited from class org.jboss.resteasy.spi.AsyncOutputStream

      `asyncWrite`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### HeaderFlushedAsyncOutputStream

          public HeaderFlushedAsyncOutputStream​(javax.ws.rs.core.MultivaluedMap<String,​Object> headers,
                                                AsyncOutputStream delegate)

  - ### Method Detail

    - #### flushHeaders

          protected CompletionStage<Void> flushHeaders()

    - #### write

          public void write​(int i)
                     throws IOException

      Specified by:
        `write` in class `OutputStream`
      Throws:
        `IOException`

    - #### write

          public void write​(byte[] bytes)
                     throws IOException

      Overrides:
        `write` in class `OutputStream`
      Throws:
        `IOException`

    - #### write

          public void write​(byte[] bytes,
                            int i,
                            int i1)
                     throws IOException

      Overrides:
        `write` in class `OutputStream`
      Throws:
        `IOException`

    - #### flush

          public void flush()
                     throws IOException

      Specified by:
        `flush` in interface `Flushable`
      Overrides:
        `flush` in class `OutputStream`
      Throws:
        `IOException`

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `Closeable`
      Overrides:
        `close` in class `OutputStream`
      Throws:
        `IOException`

    - #### asyncFlush

          public CompletionStage<Void> asyncFlush()

      Description copied from class: `AsyncOutputStream`
      Flushes this async output stream.
      Specified by:
        `asyncFlush` in class `AsyncOutputStream`
      Returns:
        a `CompletionStage` notified on completion of the flush operation.

    - #### asyncWrite

          public CompletionStage<Void> asyncWrite​(byte[] bytes,
                                                  int offset,
                                                  int length)

      Description copied from class: `AsyncOutputStream`
      Writes to this async output stream.
      Specified by:
        `asyncWrite` in class `AsyncOutputStream`
      Parameters:
        `bytes` - the bytes to write
        `offset` - the offset from which to start writing in the given byte array.
        `length` - the number of bytes to write from the given byte array
      Returns:
        a `CompletionStage` notified on completion of the write operation.